/* Tabela SEGMERCADO: Item do Lanamento de Estoque */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela SEGMERCADO */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela SEGMERCADO utilizando a tabela Geral de Logs de Operaes */

IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'LOG_GER_SEGMERCADO'   AND
                 TYPE   = 'TR'                   AND
	              U.UID  = O.UID                  AND
	              U.NAME = USER)
DROP TRIGGER LOG_GER_SEGMERCADO
GO


CREATE TRIGGER LOG_GER_SEGMERCADO
ON SEGMERCADO
FOR INSERT, UPDATE, DELETE
AS
   DECLARE  @V_USUARIO      VARCHAR(40);
   DECLARE  @V_TIPO         VARCHAR(1);
   DECLARE  @V_ITPESQ       VARCHAR(40);
   DECLARE  @V_DESC         VARCHAR(300);
   DECLARE  @V_DTOPER       DATETIME;

/*VARIVEIS DO CURSOR C_CURSOR*/

   DECLARE  @V_ID_COMANDO   VARCHAR(1);

   DECLARE  @V_OLD_CDSEGMER VARCHAR(5);
   DECLARE  @V_OLD_DSSEGMER VARCHAR(24);
   DECLARE  @V_NEW_CDSEGMER VARCHAR(5);
   DECLARE  @V_NEW_DSSEGMER VARCHAR(24);

BEGIN

   SET @V_TIPO = '0';
   SET @V_DESC = '';
   EXEC NMUSUARIO @V_USUARIO;
   SET @V_USUARIO = ISNULL(@V_USUARIO, '');

   DECLARE C_CURSOR CURSOR FOR
   SELECT
      'D' IDCOMANDO,
	   CDSEGMER,
      DSSEGMER,
      NULL,
      NULL
   FROM
      DELETED
   WHERE
      CDSEGMER NOT IN (SELECT CDSEGMER FROM INSERTED)

   UNION ALL

   SELECT
      'U' IDCOMANDO,
      DELETED.CDSEGMER,
      DELETED.DSSEGMER,
      INSERTED.CDSEGMER,
      INSERTED.DSSEGMER
   FROM
      INSERTED,
      DELETED
   WHERE
      INSERTED.CDSEGMER  = DELETED.CDSEGMER
   UNION ALL

   SELECT
      'I' IDCOMANDO,
      NULL,
      NULL,
      CDSEGMER,
      DSSEGMER

   FROM
      INSERTED
   WHERE
      CDSEGMER NOT IN (SELECT  CDSEGMER FROM DELETED);

   OPEN C_CURSOR;
   FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
                                 @V_OLD_CDSEGMER,
                                 @V_OLD_DSSEGMER,
                                 @V_NEW_CDSEGMER,
                                 @V_NEW_DSSEGMER;

   WHILE (@@FETCH_STATUS = 0) BEGIN
      IF @V_ID_COMANDO = 'D' BEGIN
         IF @V_OLD_CDSEGMER IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Cod=' + @V_OLD_CDSEGMER;
         END;
         IF @V_OLD_DSSEGMER IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' Descr=' + @V_OLD_DSSEGMER;
         END;
         SET @V_TIPO         = '3';
         SET @V_ITPESQ       = @V_OLD_CDSEGMER;
      END
      ELSE BEGIN
         IF @V_ID_COMANDO = 'U' /*UPDATING*/ BEGIN
            IF (@V_OLD_DSSEGMER <> @V_NEW_DSSEGMER) BEGIN
               SET @V_TIPO         = '2';
               SET @V_ITPESQ       = @V_OLD_CDSEGMER;
            END;
         END
         ELSE BEGIN
            SET @V_TIPO         = '1';
            SET @V_ITPESQ       = @V_NEW_CDSEGMER;
         END;
         IF ISNULL(@V_NEW_CDSEGMER,'!') <> ISNULL(@V_OLD_CDSEGMER,'!') BEGIN
            SET @V_DESC = @V_DESC + ' Cod=' + @V_NEW_CDSEGMER;
         END;

         IF ISNULL(@V_NEW_DSSEGMER ,'!') <> ISNULL(@V_OLD_DSSEGMER, '!') BEGIN
            SET @V_DESC = @V_DESC + ' Descr=' + @V_NEW_DSSEGMER;
         END;
      END;

      IF @V_TIPO <> '0' BEGIN
         EXEC NMUSUARIO @V_USUARIO;
         IF NOT @V_DESC IS NULL BEGIN
            IF NOT @V_USUARIO IS NULL BEGIN
               SET @V_DTOPER = GETDATE();
               INSERT INTO LOGOPERA
                  (NMTABELA,   DTOPERACAO, NMRESPOPER,
                   IDTIPOOPER, CDPESQITEM, DSOPERACAO)
               VALUES
                  ('SEGMERCADO',  @V_DTOPER, @V_USUARIO,
                   @V_TIPO,      @V_ITPESQ, @V_DESC);
            END;
         END;
      END;
      FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
                                    @V_OLD_CDSEGMER,
                                    @V_OLD_DSSEGMER,
                                    @V_NEW_CDSEGMER,
                                    @V_NEW_DSSEGMER;



   END;
   CLOSE      C_CURSOR;
   DEALLOCATE C_CURSOR;
END;
GO


-- VERSAO --
EXEC ATUVEROBJ 'LOG_GER_SEGMERCADO','4.11.105';
GO

